org.apache.commons.math3.distribution

## Class BinomialDistribution

- java.lang.Object
- - org.apache.commons.math3.distribution.AbstractIntegerDistribution
  - - org.apache.commons.math3.distribution.BinomialDistribution

All Implemented Interfaces:
  Serializable, IntegerDistribution

    public class BinomialDistribution
    extends AbstractIntegerDistribution

Implementation of the binomial distribution.

Version:
  $Id: BinomialDistribution.java 1416643 2012-12-03 19:37:14Z tn $
See Also:
  Binomial distribution (Wikipedia), Binomial Distribution (MathWorld), Serialized Form

### Field Summary

Fields
`private int` `numberOfTrials` The number of trials.
`private double` `probabilityOfSuccess` The probability of success.
`private static long` `serialVersionUID` Serializable version identifier.

### Fields inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

`random, randomData`

### Constructor Summary

Constructors
Constructor and Description
`BinomialDistribution(int trials, double p)` Create a binomial distribution with the given number of trials and probability of success.
`BinomialDistribution(RandomGenerator rng, int trials, double p)` Creates a binomial distribution.

### Method Summary

Methods
`double` `cumulativeProbability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`int` `getNumberOfTrials()` Access the number of trials for this distribution.
`double` `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
`double` `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
`double` `getProbabilityOfSuccess()` Access the probability of success for this distribution.
`int` `getSupportLowerBound()` Access the lower bound of the support.
`int` `getSupportUpperBound()` Access the upper bound of the support.
`boolean` `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
`double` `probability(int x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`.

### Methods inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

`cumulativeProbability, inverseCumulativeProbability, reseedRandomGenerator, sample, sample, solveInverseCumulativeProbability`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### serialVersionUID

    private static final long serialVersionUID

Serializable version identifier.

See Also:
  Constant Field Values

#### numberOfTrials

    private final int numberOfTrials

The number of trials.

#### probabilityOfSuccess

    private final double probabilityOfSuccess

The probability of success.

### Constructor Detail

#### BinomialDistribution

    public BinomialDistribution(int trials,
                        double p)

Create a binomial distribution with the given number of trials and probability of success.

Parameters:
  `trials` - Number of trials.
  `p` - Probability of success.
Throws:
  `NotPositiveException` - if `trials < 0`.
  `OutOfRangeException` - if `p < 0` or `p > 1`.

#### BinomialDistribution

    public BinomialDistribution(RandomGenerator rng,
                        int trials,
                        double p)

Creates a binomial distribution.

Parameters:
  `rng` - Random number generator.
  `trials` - Number of trials.
  `p` - Probability of success.
Throws:
  `NotPositiveException` - if `trials < 0`.
  `OutOfRangeException` - if `p < 0` or `p > 1`.
Since:
  3.1

### Method Detail

#### getNumberOfTrials

    public int getNumberOfTrials()

Access the number of trials for this distribution.

Returns:
  the number of trials.

#### getProbabilityOfSuccess

    public double getProbabilityOfSuccess()

Access the probability of success for this distribution.

Returns:
  the probability of success.

#### probability

    public double probability(int x)

For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`. In other words, this method represents the probability mass function (PMF) for the distribution.

Parameters:
  `x` - the point at which the PMF is evaluated
Returns:
  the value of the probability mass function at `x`

#### cumulativeProbability

    public double cumulativeProbability(int x)

For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

#### getNumericalMean

    public double getNumericalMean()

Use this method to get the numerical value of the mean of this distribution. For `n` trials and probability parameter `p`, the mean is `n * p`.

Returns:
  the mean or `Double.NaN` if it is not defined

#### getNumericalVariance

    public double getNumericalVariance()

Use this method to get the numerical value of the variance of this distribution. For `n` trials and probability parameter `p`, the variance is `n * p * (1 - p)`.

Returns:
  the variance (possibly `Double.POSITIVE_INFINITY` or `Double.NaN` if it is not defined)

#### getSupportLowerBound

    public int getSupportLowerBound()

Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in Z | P(X <= x) > 0}`.

The lower bound of the support is always 0 except for the probability parameter `p = 1`.

Returns:
  lower bound of the support (0 or the number of trials)

#### getSupportUpperBound

    public int getSupportUpperBound()

Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X <= x) = 1}`.

The upper bound of the support is the number of trials except for the probability parameter `p = 0`.

Returns:
  upper bound of the support (number of trials or 0)

#### isSupportConnected

    public boolean isSupportConnected()

Use this method to get information about whether the support is connected, i.e. whether all integers between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

Returns:
  `true`